/**
* @file		AHFBase.h
*
* @brief	{IȒ`
*
* @author	ISHINO k16
*
* $Id: AHBase.h 3188 2018-10-23 00:13:48Z nakashima-s $
*
* Copyright (C) 2002-2005, Antenna House, Inc.  All Rights Reserved.
*/

#ifndef AHBASE_H__
#define AHBASE_H__

#ifndef AH_PLATFORMDEFS_H_
#include <AH/AHPlatformDefs.h>
#endif

#include "AHCommonVersion.h"

////////////////////////////////////////////////////////////////////////////////

#ifdef AH_WIN_MSC_
	#pragma warning(disable: 4786) // identifier was truncated to '255' characters
	#pragma warning(disable: 4800) // forcing value to bool 'true' or 'false'

	#if _MSC_VER<1400
		#error VC8 or later should be used
	#endif
	#ifdef AHCOMMON_NODLL
		#define AHCOMMON_API
	#else
		#ifdef AHCOMMON_EXPORTS
			#define AHCOMMON_API __declspec(dllexport)
		#else
			#define AHCOMMON_API __declspec(dllimport)
		#endif
	#endif
#else
		#define AHCOMMON_API
#endif

// AHCommonnamespace
//#define AHCommonNS	AHCommonNS

////////////////////////////////////////////////////////////////////////////////
// z̗vf𓾂}N

#define elementsof(array) (sizeof(array)/sizeof(array[0]))

////////////////////////////////////////////////////////////////////////////////
// V{̕

#define	defstr(a)		defstr2(a)
#define	defstr2(a)		defstr1(a)
#define	defstr1(a)		#a

////////////////////////////////////////////////////////////////////////////////
// {̌^

/*
	ICU CuŎg{IȌ^`Ȃǂ𗘗p.
	ȉ̂悤Ȓ`ɂAvbgtH[̈ႢzB
	iۂ̒`e̓vbgtH[ŕςj

		typedef signed char			int8_t;
		typedef unsigned char		uint8_t;
		typedef signed short		int16_t;
		typedef unsigned short		uint16_t;
		typedef signed long			int32_t;
		typedef unsigned long		uint32_t;
		typedef signed __int64		int64_t;
		typedef unsigned __int64	uint64_t;

		typedef uint16_t			UChar;
		typedef int32_t				UChar32;
*/

#include <unicode/utypes.h>

#if AHCOMMONVER==200
  #if defined _MSC_VER && _MSC_VER<1900	// b
    #if U_ICU_VERSION_MAJOR_NUM != 55
    #error ICU 55 should be used!
    #endif
  #else
    #if U_ICU_VERSION_MAJOR_NUM != 60
    #error ICU 60 should be used!
    #endif
  #endif
#elif AHCOMMONVER==106
	#if U_ICU_VERSION_MAJOR_NUM != 55
	#error ICU 55 should be used!
	#endif
#elif AHCOMMONVER==103 || AHCOMMONVER==104 || AHCOMMONVER==105
	#if U_ICU_VERSION_MAJOR_NUM != 52
	#error ICU 52 should be used!
	#endif
#elif AHCOMMONVER==102
	#if U_ICU_VERSION_MAJOR_NUM != 50
	#error ICU 50 should be used!
	#endif
#elif AHCOMMONVER==100 || AHCOMMONVER==101
	#if !(U_ICU_VERSION_MAJOR_NUM == 4 && U_ICU_VERSION_MINOR_NUM == 0)
	#error ICU 4.0 should be used!
	#endif
#else
	#error Unknown ICU version is used.
#endif

//////////////////////////////////////////////////////////////
// GfBAlt@C\p⏕NX
// : namespaceO

#if 0//ndef AH_HAVE_BIG_ENDIAN
: t@C\ɗp邽߁Â悤ȂƂĂ͂Ȃ (packȂ)
typedef uint16_t uint16_le;
typedef uint32_t uint32_le;
typedef uint64_t uint64_le;
typedef int16_t int16_le;
typedef int32_t int32_le;
typedef int64_t int64_le;
#else
class uint16_le {
private:
	uint8_t		le[2];
public:
	operator uint16_t() const { return le[0] | ((uint16_t)le[1]<<8); }
	uint16_le() {}
	uint16_le(uint16_t v) {
		le[0] = (uint8_t)v;
		le[1] = (uint8_t)(v>>8);
	}
};
class int16_le {
private:
	uint8_t		le[2];
public:
	operator int16_t() const { return le[0] | ((uint16_t)le[1]<<8); }
	int16_le() {}
	int16_le(int16_t v) {
		le[0] = (uint8_t)v;
		le[1] = (uint8_t)(v>>8);
	}
};
class uint32_le {
private:
	uint16_le	le[2];
public:
	operator uint32_t() const
		{ return uint16_t(le[0]) | ((uint32_t)(uint16_t)le[1]<<16); }
	uint32_le() {}
	uint32_le(uint32_t v) {
		le[0] = (uint16_t)v;
		le[1] = (uint16_t)(v>>16);
	}
};
class int32_le {
private:
	uint16_le	le[2];
public:
	operator int32_t() const
		{ return uint16_t(le[0]) | ((uint32_t)(uint16_t)le[1]<<16); }
	int32_le() {}
	int32_le(int32_t v) {
		le[0] = (uint16_t)v;
		le[1] = (uint16_t)(v>>16);
	}
};
class uint64_le {
private:
	uint32_le	le[2];
public:
	operator uint64_t() const
		{ return uint32_t(le[0]) | ((uint64_t)(uint32_t)le[1]<<32); }
	uint64_le() {}
	uint64_le(uint64_t v) {
		le[0] = (uint32_t)v;
		le[1] = (uint32_t)(v>>32);
	}
};
class int64_le {
private:
	uint32_le	le[2];
public:
	operator int64_t() const
		{ return uint32_t(le[0]) | ((uint64_t)(uint32_t)le[1]<<32); }
	int64_le() {}
	int64_le(int64_t v) {
		le[0] = (uint32_t)v;
		le[1] = (uint32_t)(v>>32);
	}
};
#endif
class uint24_le {
private:
	uint8_t		le[3];
public:
	operator uint32_t() const
		{ return le[0] | ((uint32_t)le[1]<<8) | ((uint32_t)le[2]<<16); }
	uint24_le() {}
	uint24_le(uint32_t v) {
		le[0] = (uint8_t)v;
		le[1] = (uint8_t)(v>>8);
		le[2] = (uint8_t)(v>>16);
	}
};

#if 0//def AH_HAVE_BIG_ENDIAN
: t@C\ɗp邽߁Â悤ȂƂĂ͂Ȃ (packȂ)
typedef uint16_t uint16_be;
typedef uint32_t uint32_be;
typedef uint64_t uint64_be;
typedef int16_t int16_be;
typedef int32_t int32_be;
typedef int64_t int64_be;
#else
class uint16_be {
private:
	uint8_t		be[2];
public:
	operator uint16_t() const { return be[1] | ((uint16_t)be[0]<<8); }
	uint16_be() {}
	uint16_be(uint16_t v) {
		be[1] = (uint8_t)v;
		be[0] = (uint8_t)(v>>8);
	}
};
class int16_be {
private:
	uint8_t		be[2];
public:
	operator int16_t() const { return be[1] | ((uint16_t)be[0]<<8); }
	int16_be() {}
	int16_be(int16_t v) {
		be[1] = (uint8_t)v;
		be[0] = (uint8_t)(v>>8);
	}
};
class uint32_be {
private:
	uint16_be	be[2];
public:
	operator uint32_t() const
		{ return uint16_t(be[1]) | ((uint32_t)(uint16_t)be[0]<<16); }
	uint32_be() {}
	uint32_be(uint32_t v) {
		be[1] = (uint16_t)v;
		be[0] = (uint16_t)(v>>16);
	}
};
class int32_be {
private:
	uint16_be	be[2];
public:
	operator int32_t() const
		{ return uint16_t(be[1]) | ((uint32_t)(uint16_t)be[0]<<16); }
	int32_be() {}
	int32_be(int32_t v) {
		be[1] = (uint16_t)v;
		be[0] = (uint16_t)(v>>16);
	}
};
class uint64_be {
private:
	uint32_be	be[2];
public:
	operator uint64_t() const
		{ return uint32_t(be[1]) | ((uint64_t)(uint32_t)be[0]<<32); }
	uint64_be() {}
	uint64_be(uint64_t v) {
		be[1] = (uint32_t)v;
		be[0] = (uint32_t)(v>>32);
	}
};
class int64_be {
private:
	uint32_be	be[2];
public:
	operator int64_t() const
		{ return uint32_t(be[1]) | ((uint64_t)(uint32_t)be[0]<<32); }
	int64_be() {}
	int64_be(int64_t v) {
		be[1] = (uint32_t)v;
		be[0] = (uint32_t)(v>>32);
	}
};
#endif
class uint24_be {
private:
	uint8_t		be[3];
public:
	operator uint32_t() const
		{ return be[2] | ((uint32_t)be[1]<<8) | ((uint32_t)be[0]<<16); }
	uint24_be() {}
	uint24_be(uint32_t v) {
		be[2] = (uint8_t)v;
		be[1] = (uint8_t)(v>>8);
		be[0] = (uint8_t)(v>>16);
	}
};

////////////////////////////////////////////////////////////////////////////////

namespace AHCommonNS {

////////////////////////////////////////////////////////////////////////////////
// w̒萔

const double AH_MATH_E        = 2.71828182845904523536;
const double AH_MATH_LOG2E    = 1.44269504088896340736;
const double AH_MATH_LOG10E   = 0.434294481903251827651;
const double AH_MATH_LN2      = 0.693147180559945309417;
const double AH_MATH_LN10     = 2.30258509299404568402;
const double AH_MATH_PI       = 3.14159265358979323846;
const double AH_MATH_SQRT2    = 1.41421356237309504880;
const double AH_MATH_SQRT1_2  = 0.707106781186547524401;


} //namespace AHCommonNS

////////////////////////////////////////////////////////////////////////////////
/*
	MSVC6  min, max ΍

	STL ̃wb_t@C algorithm CN[hOɂ̒`邱ƂŁA
	min, max ev[g֐g悤ɂ.
	Windows ̃wb_ min, max }NƂčĒ`Ă܂̂hɂ́A
	V{ NOMINMAX `Ă Windows wb_CN[h.
*/
#ifdef _MSC_VER
#pragma warning(disable: 4786) // identifier was truncated to '255' characters
#pragma warning(disable: 4800) // forcing value to bool 'true' or 'false'

	#if defined _cpp_min || defined _cpp_max
		#error Please include AHBase.h in front of STL.
	#endif

	#undef min
	#undef max
	#define _cpp_min		min
	#define _cpp_max		max
	#define NOMINMAX
#endif
//#include <algorithm>


#endif // AHBASE_H__
